(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/common'), require('@angular/material-moment-adapter'), require('moment/moment'), require('@angular/core'), require('@angular/platform-browser'), require('@angular/forms'), require('@angular/common/http'), require('@angular/platform-browser/animations'), require('@angular/material'), require('@mat-datetimepicker/moment'), require('@mat-datetimepicker/core')) :
    typeof define === 'function' && define.amd ? define('mat-dynamic-table', ['exports', 'rxjs', 'rxjs/operators', '@angular/common', '@angular/material-moment-adapter', 'moment/moment', '@angular/core', '@angular/platform-browser', '@angular/forms', '@angular/common/http', '@angular/platform-browser/animations', '@angular/material', '@mat-datetimepicker/moment', '@mat-datetimepicker/core'], factory) :
    (factory((global['mat-dynamic-table'] = {}),global.rxjs,global.rxjs.operators,global.ng.common,global.ng['material-moment-adapter'],global.moment,global.ng.core,global.ng.platformBrowser,global.ng.forms,global.ng.common.http,global.ng.platformBrowser.animations,global.ng.material,global.moment$1,global.core));
}(this, (function (exports,rxjs,operators,common,materialMomentAdapter,moment,i0,platformBrowser,forms,i1,animations,material,moment$1,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatDynamicTableService = /** @class */ (function () {
        function MatDynamicTableService(http) {
            this.http = http;
        }
        /**
         * @param {?} valueColumns
         * @param {?} pageSize
         * @param {?} pageIndex
         * @param {?} api
         * @param {?} key
         * @param {?} direction
         * @return {?}
         */
        MatDynamicTableService.prototype.searchFilter = /**
         * @param {?} valueColumns
         * @param {?} pageSize
         * @param {?} pageIndex
         * @param {?} api
         * @param {?} key
         * @param {?} direction
         * @return {?}
         */
            function (valueColumns, pageSize, pageIndex, api, key, direction) {
                /** @type {?} */
                var headers = new i1.HttpHeaders({ 'Content-Type': 'application/json' });
                /** @type {?} */
                var valueColumnsParsed = JSON.parse(JSON.stringify(valueColumns));
                if (valueColumnsParsed.hasOwnProperty('details')) {
                    delete valueColumnsParsed.details;
                }
                /** @type {?} */
                var requestBody = {
                    columns: valueColumnsParsed,
                    pagination: {
                        pageSize: pageSize,
                        pageIndex: pageIndex,
                    },
                    sort: {
                        key: key,
                        direction: direction
                    }
                };
                return this.http.post(api, requestBody, { headers: headers }).pipe(operators.map(( /**
                 * @param {?} res
                 * @return {?}
                 */function (res) { return res; })));
            };
        MatDynamicTableService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        MatDynamicTableService.ctorParameters = function () {
            return [
                { type: i1.HttpClient }
            ];
        };
        /** @nocollapse */ MatDynamicTableService.ngInjectableDef = i0.defineInjectable({ factory: function MatDynamicTableService_Factory() { return new MatDynamicTableService(i0.inject(i1.HttpClient)); }, token: MatDynamicTableService, providedIn: "root" });
        return MatDynamicTableService;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = {
        parse: {
            dateInput: 'L',
            monthInput: 'MMMM',
            yearInput: 'YYYY',
            timeInput: 'LT',
            datetimeInput: 'L LT'
        },
        display: {
            dateInput: 'L',
            monthInput: 'MMMM',
            yearInput: 'YYYY',
            datetimeInput: 'L LT',
            timeInput: 'LT',
            monthYearLabel: 'MMM YYYY',
            dateA11yLabel: 'LL',
            monthYearA11yLabel: 'MMMM YYYY',
            popupHeaderDateLabel: 'ddd, DD MMM'
        }
    };
    var MatDynamicTableComponent = /** @class */ (function () {
        function MatDynamicTableComponent(backendApi) {
            this.backendApi = backendApi;
            this.dataSource = new material.MatTableDataSource();
            this.displayedColumns = [];
            this.onSpecial = new i0.EventEmitter();
            this.displayedTypeColumns = {};
            this.sortObject = {};
            this.resultsLength = 0;
            this.isLoadingResults = false;
            this.isRateLimitReached = false;
            this.dataStatus = 'loaded';
            this.typeColumns = {};
            this.columnsObject = {};
            this.valueColumns = {};
            this.datePipe = new common.DatePipe("en");
            this.today = moment.utc().year(1929);
            this.tomorrow = moment.utc().date(moment.utc().date() + 1);
            this.min = this.today.clone().year(2018).month(10).date(3).hour(11).minute(10);
            this.max = this.min.clone().date(4).minute(45);
            this.start = this.today.clone().year(1930).month(9).date(28);
            this.filter = ( /**
             * @param {?} date
             * @param {?} type
             * @return {?}
             */function (date, type) {
                switch (type) {
                    case core.MatDatetimepickerFilterType.DATE:
                        return date.year() % 2 === 0 &&
                            date.month() % 2 === 0 &&
                            date.date() % 2 === 0;
                    case core.MatDatetimepickerFilterType.HOUR:
                        return date.hour() % 2 === 0;
                    case core.MatDatetimepickerFilterType.MINUTE:
                        return date.minute() % 2 === 0;
                }
            });
        }
        /**
         * @return {?}
         */
        MatDynamicTableComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.typeColumns = this.displayedTypeColumns;
                this.columnsObject = this.displayedTypeColumns;
                this.getHeaderKeys();
                if (Object.entries(this.sortObject).length === 0) {
                    this.error = new Error('sortObject is required');
                    this.dataStatus = 'error';
                    throw this.error;
                }
                if (Object.entries(this.typeColumns).length === 0) {
                    this.error = new Error('displayedTypeColumns is required');
                    this.dataStatus = 'error';
                    throw this.error;
                }
                if (!this.api) {
                    this.error = new Error('api is required');
                    this.dataStatus = 'error';
                    throw this.error;
                }
            };
        /**
         * @return {?}
         */
        MatDynamicTableComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.searchFilter();
                }));
            };
        /**
         * @return {?}
         */
        MatDynamicTableComponent.prototype.searchFilter = /**
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    var key, direction;
                    var _this = this;
                    return __generator(this, function (_a) {
                        this.dataSource.data = [];
                        this.dataStatus = 'loading';
                        // Boolean Columns parse
                        Object.keys(this.valueColumns).forEach(( /**
                         * @param {?} x
                         * @return {?}
                         */function (x) {
                            if (_this.valueColumns[x] === 'true') {
                                _this.valueColumns[x] = true;
                            }
                            else if (_this.valueColumns[x] === 'false') {
                                _this.valueColumns[x] = false;
                            }
                            if (_this.valueColumns[x] === null) {
                                _this.valueColumns[x] = '';
                            }
                        }));
                        //Default sort
                        if (this.sort.active === undefined || this.sort.direction === '') {
                            key = this.sortObject.key;
                            direction = this.sortObject.direction;
                        }
                        else {
                            key = this.sort.active;
                            direction = this.sort.direction;
                        }
                        this.dataSource.sort = this.sort;
                        this.sort.sortChange.subscribe(( /**
                         * @return {?}
                         */function () { return _this.paginator.pageIndex = 0; }));
                        rxjs.merge()
                            .pipe(operators.startWith({}), operators.switchMap(( /**
                     * @return {?}
                     */function () {
                            return _this.backendApi.searchFilter(_this.valueColumns, _this.paginator.pageSize, _this.paginator.pageIndex, _this.api, key, direction);
                        })), operators.map(( /**
                         * @param {?} data
                         * @return {?}
                         */function (data) {
                            _this.isLoadingResults = false;
                            _this.isRateLimitReached = false;
                            _this.resultsLength = data.totals.length;
                            return data;
                        })), operators.catchError(( /**
                         * @return {?}
                         */function () {
                            _this.isLoadingResults = false;
                            _this.isRateLimitReached = true;
                            return rxjs.of([]);
                        }))).subscribe(( /**
                         * @param {?} data
                         * @return {?}
                         */function (data) {
                            if (!data.data || !data.totals) {
                                _this.error = new Error('data and totals are required');
                                _this.dataStatus = 'error';
                                throw _this.error;
                            }
                            _this.dataSource.data = data.data;
                            if (_this.dataSource.data.length == 0) {
                                _this.dataStatus = 'noData';
                            }
                            if (_this.dataSource.data.length > 0) {
                                _this.dataStatus = 'loaded';
                            }
                        }));
                        return [2 /*return*/];
                    });
                });
            };
        /**
         * @param {?} header
         * @return {?}
         */
        MatDynamicTableComponent.prototype.formatHeader = /**
         * @param {?} header
         * @return {?}
         */
            function (header) {
                if (header.includes('.')) {
                    /** @type {?} */
                    var splited = header.split(".");
                    /** @type {?} */
                    var result = splited[1].replace(/([A-Z])/g, " $1");
                    /** @type {?} */
                    var finalResult = result.charAt(0).toUpperCase() + result.slice(1);
                    return finalResult;
                }
                else {
                    /** @type {?} */
                    var result = header.replace(/([A-Z])/g, " $1");
                    /** @type {?} */
                    var finalResult = result.charAt(0).toUpperCase() + result.slice(1);
                    return finalResult;
                }
            };
        /**
         * @return {?}
         */
        MatDynamicTableComponent.prototype.getHeaderKeys = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // Iterating and setting static types e.g. type "date/text/number/boolean" else delete
                Object.keys(this.typeColumns).forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    if (_this.typeColumns[key].toLowerCase() == "string" || _this.typeColumns[key].toLowerCase() == "array" || _this.typeColumns[key].toLowerCase() == "text") {
                        _this.typeColumns[key] = "text";
                    }
                    else if (_this.typeColumns[key].toLowerCase() == "long" || _this.typeColumns[key].toLowerCase() == "int" || _this.typeColumns[key].toLowerCase() == "double" || _this.typeColumns[key].toLowerCase() == "number") {
                        _this.typeColumns[key] = "number";
                    }
                    else if (_this.typeColumns[key].toLowerCase() == "date" || _this.typeColumns[key].toLowerCase() == "boolean" || _this.typeColumns[key].toLowerCase() == "special") {
                        _this.typeColumns[key] = _this.typeColumns[key].toLowerCase();
                    }
                    else {
                        console.log("Unsuported type " + key + ":" + _this.typeColumns[key] + ", column has been deleted");
                        delete _this.typeColumns[key];
                    }
                }));
                this.displayedColumns = Object.keys(this.typeColumns);
                Object.keys(this.typeColumns).forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    _this.valueColumns[key] = '';
                }));
            };
        /**
         * @param {?} date
         * @return {?}
         */
        MatDynamicTableComponent.prototype.formatDate = /**
         * @param {?} date
         * @return {?}
         */
            function (date) {
                if (date) {
                    /** @type {?} */
                    var newDate = this._formatDate(date);
                    return newDate;
                }
                else {
                    return 'No Date';
                }
            };
        /**
         * @param {?} date
         * @param {?=} format
         * @return {?}
         */
        MatDynamicTableComponent.prototype._formatDate = /**
         * @param {?} date
         * @param {?=} format
         * @return {?}
         */
            function (date, format) {
                if (format) {
                    return this.datePipe.transform(date, format);
                }
                else {
                    return this.datePipe.transform(date, 'MMM d, y, HH:mm:ss');
                }
            };
        /**
         * @param {?} word
         * @param {?} element
         * @return {?}
         */
        MatDynamicTableComponent.prototype.spliceWord = /**
         * @param {?} word
         * @param {?} element
         * @return {?}
         */
            function (word, element) {
                if (word != null && word.includes('.')) {
                    /** @type {?} */
                    var splited = word.split(".");
                    /** @type {?} */
                    var first = splited[0];
                    /** @type {?} */
                    var second = splited[1];
                    /** @type {?} */
                    var result = void 0;
                    if (element[first] === null || element[first].length < 1) {
                        result = 'No Data';
                        return result;
                    }
                    else {
                        result = element[first][0][second];
                        return result;
                    }
                }
                else {
                    /** @type {?} */
                    var result = void 0;
                    if (element[word] == null) {
                        result = 'No Data';
                        return result;
                    }
                    else {
                        result = element[word];
                        return result;
                    }
                }
            };
        /**
         * @param {?} element
         * @return {?}
         */
        MatDynamicTableComponent.prototype.onSpecialClick = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                this.onSpecial.emit(element);
            };
        MatDynamicTableComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mat-dynamic-table',
                        template: "<div class=\"example-container mat-elevation-z8\">\n\n  <mat-table #table [dataSource]=\"dataSource\" matSort>\n\n    <ng-container *ngFor=\"let disCol of typeColumns | keyvalue; let i = index\" matColumnDef={{disCol.key}}>\n\n      <mat-header-cell *matHeaderCellDef> \n\n        <div *ngIf=\"disCol.key != 'details'\" style=\"width: 25%\"></div>    \n\n          <mat-form-field *ngIf=\"disCol.value=='date' && disCol.key!=='details'\" style=\"text-align:center;width: 75%\" (click)=\"$event.stopPropagation();\" title=\"{{formatHeader(disCol.key)}}\">\n            <mat-datetimepicker-toggle [for]=\"datetimePicker2\" matSuffix></mat-datetimepicker-toggle>\n            <mat-datetimepicker #datetimePicker2 type=\"datetime\" startView=\"month\" openOnFocus=\"true\" timeInterval=\"5\"></mat-datetimepicker>\n            <input matInput placeholder={{formatHeader(disCol.key)}} name=\"startTransactionTimeStamp\" #startTransactionTimeStamp (dateInput)=\"searchFilter()\"\n              [min]=\"today\" [max]=\"tomorrow\" [matDatetimepicker]=\"datetimePicker2\" autocomplete=\"false\" [(ngModel)]=valueColumns[disCol.key]>\n          </mat-form-field>\n          \n          <mat-form-field *ngIf=\"disCol.value=='boolean' && disCol.key!=='details'\" style=\"text-align:center;width: 75%;\"(click)=\"$event.stopPropagation();\" title=\"{{formatHeader(disCol.key)}}\">\n            <mat-select [(ngModel)]=\"valueColumns[disCol.key]\" placeholder=\"{{formatHeader(disCol.key)}}\" style=\"text-align: center;width:75%\"\n              (selectionChange)=\"searchFilter()\" name={{disCol.key}} #{{disCol.key}}>\n              <mat-option value=\"\">All</mat-option> \n              <mat-option value=\"true\">True</mat-option> \n              <mat-option value=\"false\">False</mat-option> \n            </mat-select>\n          </mat-form-field>\n\n          <mat-form-field *ngIf=\"disCol.value=='text' && disCol.key!=='details'\" style=\"text-align:center;width: 75%\" (click)=\"$event.stopPropagation();\" title=\"{{formatHeader(disCol.key)}}\">\n            <input matInput type=\"text\" class=\"form-control\" style=\"text-align:center;border: none !important\" placeholder={{formatHeader(disCol.key)}} (change)=\"searchFilter()\" name={{disCol.key}} #{{disCol.key}} [(ngModel)]=valueColumns[disCol.key] >\n          </mat-form-field>\n\n          <mat-form-field *ngIf=\"disCol.value=='number' && disCol.key!=='details'\" style=\"text-align:center;width: 75%\" (click)=\"$event.stopPropagation();\" title=\"{{formatHeader(disCol.key)}}\">\n              <input matInput type=\"number\" class=\"form-control\" style=\"text-align:center;border: none !important\" placeholder={{formatHeader(disCol.key)}} (change)=\"searchFilter()\" name={{disCol.key}} #{{disCol.key}} [(ngModel)]=valueColumns[disCol.key] >\n          </mat-form-field>\n        <h6 *ngIf=\"disCol.key=='details'\" class=\"headerH6\" title=\"{{formatHeader(disCol.key)}}\"> Details </h6>\n        <div *ngIf=\"disCol.key != 'details'\" style=\"width: 25%\" mat-sort-header={{disCol.key}} (click)=\"searchFilter()\"></div>\n      </mat-header-cell>\n\n      <mat-cell style=\"text-align:center\" *matCellDef=\"let element;let i = index\" [style.visibility]=\"dataStatus==='loaded'?'visible':'hidden'\">\n        <span *ngIf=\"dataStatus == 'loaded' && disCol.value=='date'\">{{formatDate(element[disCol.key])}}</span>\n        <span *ngIf=\"dataStatus == 'loaded' && disCol.key == 'details'\" (click)=\"onSpecialClick(element)\">        \n          <i class=\"material-icons\" *ngIf=\"!element[disCol.key]\">info</i>{{element[disCol.key] ? element[disCol.key] : '' }}\n        </span> \n        <span *ngIf=\"dataStatus == 'loaded' && disCol.value != 'date'\">{{element[disCol.key]}}</span>\n      </mat-cell>\n\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\"></mat-row>\n\n  </mat-table>\n\n  <div *ngIf=\"dataStatus == 'loading'\" >\n      <mat-grid-list cols=\"4\" rowHeight=\"100px\">\n        <mat-grid-tile  [colspan]=\"1\" [rowspan]=\"2\"></mat-grid-tile>\n        <mat-grid-tile  [colspan]=\"2\" [rowspan]=\"2\"><mat-spinner></mat-spinner></mat-grid-tile>\n        <mat-grid-tile  [colspan]=\"1\" [rowspan]=\"2\"></mat-grid-tile>\n      </mat-grid-list>\n  </div>\n\n  <div *ngIf=\"dataStatus == 'noData'\" >\n      <mat-grid-list cols=\"4\" rowHeight=\"100px\">\n        <mat-grid-tile  [colspan]=\"1\" [rowspan]=\"1\"></mat-grid-tile>\n        <mat-grid-tile  [colspan]=\"2\" [rowspan]=\"1\"><h3>No Data for the selected filters</h3></mat-grid-tile>\n        <mat-grid-tile  [colspan]=\"1\" [rowspan]=\"1\"></mat-grid-tile>\n      </mat-grid-list>\n  </div>\n\n  <div *ngIf=\"dataStatus == 'error'\" >\n      <mat-grid-list cols=\"4\" rowHeight=\"100px\">\n        <mat-grid-tile  [colspan]=\"1\" [rowspan]=\"1\"></mat-grid-tile>\n        <mat-grid-tile  [colspan]=\"2\" [rowspan]=\"1\"><h3>{{ error }}</h3></mat-grid-tile>\n        <mat-grid-tile  [colspan]=\"1\" [rowspan]=\"1\"></mat-grid-tile>\n      </mat-grid-list>\n  </div>\n\n  <mat-paginator #paginator [length]=\"resultsLength\" [pageSize]=\"10\" [pageSizeOptions]=\"[10,20,50,100]\" (page)=\"searchFilter()\" style=\"width: 100%;\"></mat-paginator>\n\n</div>",
                        providers: [
                            {
                                provide: material.DateAdapter,
                                useClass: materialMomentAdapter.MomentDateAdapter
                            },
                            {
                                provide: core.DatetimeAdapter,
                                useClass: moment$1.MomentDatetimeAdapter
                            },
                            {
                                provide: core.MAT_DATETIME_FORMATS,
                                useValue: ɵ0
                            }
                        ],
                        styles: ["table{width:100%}th.mat-sort-header-sorted{color:#000}.mat-form-field{font-size:14px;width:100%}mat-cell{display:flex!important;justify-content:center!important}mat-header-cell{display:flex;justify-content:center;place-content:center}"]
                    }] }
        ];
        /** @nocollapse */
        MatDynamicTableComponent.ctorParameters = function () {
            return [
                { type: MatDynamicTableService }
            ];
        };
        MatDynamicTableComponent.propDecorators = {
            paginator: [{ type: i0.ViewChild, args: [material.MatPaginator,] }],
            sort: [{ type: i0.ViewChild, args: [material.MatSort,] }],
            onSpecial: [{ type: i0.Output }],
            mode: [{ type: i0.Input }],
            displayedTypeColumns: [{ type: i0.Input }],
            api: [{ type: i0.Input }],
            sortObject: [{ type: i0.Input }]
        };
        return MatDynamicTableComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MatDynamicTable = /** @class */ (function () {
        function MatDynamicTable() {
        }
        MatDynamicTable.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [MatDynamicTableComponent],
                        imports: [
                            platformBrowser.BrowserModule,
                            animations.BrowserAnimationsModule,
                            i1.HttpClientModule,
                            material.MatButtonModule,
                            material.MatSortModule,
                            material.MatTableModule,
                            material.MatInputModule,
                            material.MatPaginatorModule,
                            material.MatSelectModule,
                            material.MatDatepickerModule,
                            material.MatNativeDateModule,
                            material.MatProgressSpinnerModule,
                            material.MatListModule,
                            core.MatDatetimepickerModule,
                            moment$1.MatMomentDatetimeModule,
                            material.MatFormFieldModule,
                            material.MatIconModule,
                            material.MatGridListModule,
                            forms.FormsModule
                        ],
                        exports: [MatDynamicTableComponent]
                    },] }
        ];
        return MatDynamicTable;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.MatDynamicTableService = MatDynamicTableService;
    exports.MatDynamicTableComponent = MatDynamicTableComponent;
    exports.MatDynamicTable = MatDynamicTable;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=mat-dynamic-table.umd.js.map